TYPE QLed EXTENDS QCANVAS
    LColor AS INTEGER
    State AS BYTE
    Size AS BYTE

    SUB DrawLed
        DIM c AS INTEGER
        if QLed.State<>0 then QLed.state=1
        
        QLed.Width = QLed.Size
        QLed.Height = QLed.Size
        c = QLed.LColor

        IF QLed.state = 0 THEN c = RGB( int((c and &H0000FF)*.65) , int(((c and &H00FF00)/256)*.65) , int(((c and &HFF0000)/65536)*.65))
        
        QLed.Circle(0 , 0 , QLed.Size , QLed.Size , 0 , c)
        FOR c = int(QLed.Size/2) - 4 TO int(QLed.Size/2)
            QLed.Line(c / 2 , c , c , c / 2 , &hffffff)
        NEXT c
    END SUB

    EVENT OnPaint
        QLed.DrawLed
    END EVENT

    SUB SetState(s AS BYTE)
        QLed.State=s
        QLed.DrawLed
    END SUB
    
    Function GetState as byte
        Result=QLed.State
    end Sub
    
    SUB SetSize(s AS BYTE)
        QLed.Size = s
        QLed.DrawLed
    END SUB

    Function GetSize as byte
        Result=QLed.Size
    end Sub

    SUB SetLColor(c AS integer)
        QLed.LColor = c
        QLed.DrawLed
    END SUB

    Function GetColor as integer
        Result=QLed.LColor
    end Sub

    SUB Toggle
        QLed.State = abs(QLed.State-1)
        QLed.DrawLed
    END SUB

    CONSTRUCTOR
        LColor = &H0000FF
        Size = 8
        state = 0
    END CONSTRUCTOR
END TYPE


